<template>
  <div class="user-list-entry" v-on:click="selectUser()"
  :class="{
    selected: (this.selectedUser && this.user.contact.email == this.selectedUser.contact.email)
  }">
    <span>
      <img :src="user.picture.thumbnail" alt="user thumbnail"/>
    </span>
    <span>
      <h3>{{user.name.first}} {{user.name.last}}</h3>
      <p>{{user.contact.email}}</p>
    </span>
  </div>
</template>

<script lang="ts">
import { defineComponent } from 'vue';
import { mapState } from 'vuex'
import store from '../store';

export default defineComponent({
  computed: {
    ...mapState([
      'selectedUser',
    ]),
  },
  props: {
    user: Object,
  },
  methods: {
    selectUser() {
      store.commit('setSelectedUser', { user: this.user });
    },
  },
});
</script>

<style lang="scss">
.user-list-entry {
  display: flex;
  gap: 10px;
  background: #ffffff0d;
  transition: 0.25s;
  color: white;
  padding: 10px;
  margin: 10px;
  border-radius: 5px;
  box-shadow: 0 5px 5px #0003;
  cursor: pointer;
  &.selected,
  &:hover {
    background: #ffffff26;
  }
  img {
    border-radius: 50%;
    width: 48px;
    height: 48px;
  }
}
</style>
